odoo.define('vracoop_pos_container_qrcode.barcode_parser', function (require) {
"use strict";

var Class = require('web.Class');
var rpc = require('web.rpc');
var BarcodeParser = require('barcodes.BarcodeParser');

BarcodeParser.include({
    // returns the checksum of the ean13, or -1 if the ean has not the correct length, ean must be a string
    ean_checksum_qr: function(ean){
        var code = ean.split('');
        if(code.length !== 19){
            return -1;
        }
        var oddsum = 0, evensum = 0, total = 0;
        code = code.reverse().splice(1);
        for(var i = 0; i < code.length; i++){
            if(i % 2 === 0){
                oddsum += Number(code[i]);
            }else{
                evensum += Number(code[i]);
            }
        }
        total = oddsum * 5 + evensum * 2;
        return Number((10 - total % 10) % 10);
    },

    // returns a valid zero padded ean13 from an ean prefix. the ean prefix must be a string.
    sanitize_ean19: function(ean){
        ean = ean.substr(0,19);

        return ean.substr(0,19) + this.ean_checksum_qr(ean);
    },

});

});

